Keywordkid Posted October 26, 2012 Posted October 26, 2012 Hi folks, I have very limited lisp understanding and generally try to work with what i have already been shown. I want to set up a ribbon tool for users to enter drawing details in the document properties which will auto fill the custom fields I have set up in our template file layout tabs. Currently when the edit is comlete and the dialogue is closed the fields remain unchanged until a regen is performed. Below is my poor attempt at redefining the dwgprops command but it clearly doesn't work. ; Define Document properties to regen on close (command ".undefine" "dwgprops") (defun c:dwgprops () (setvar "cmdecho" 0) (command "-dwgprops") (command ".regen") (command ".dwgprops) (setvar "cmdecho" 1) (princ) ) If it is possible I'd welcome some pointers - thanks. Quote
BlackBox Posted October 26, 2012 Posted October 26, 2012 (edited) Couple of things.... First, you seem to be missing a close quote here: Keywordkid said: ; Define Document properties to regen on close (command ".undefine" "dwgprops") (defun c:dwgprops () (setvar "cmdecho" 0) (command "-dwgprops") (command ".regen") (command ".dwgprops[color=red][b]"[/b][/color]) (setvar "cmdecho" 1) (princ) ) If it is possible I'd welcome some pointers - thanks. Your logic is sound, in that you're wanting the changes made to DwgProps to be reflected when you're done making changes. Where you've overlooked one option for accomplishing this is by not having a bit more experience - Don't worry, you'll get there. When you consider that you're wanting to consistently perform a supplementary action following a specific Command, Undefining, and Redefining is one way to go about it. Were I to do this (and I may now add this to my setup, so for that I thank you for asking the question), I would employ a simple Command Reactor. By using a Visual LISP Command Reactor, we can preclude the need to undefine a Command (in this case DwgProps), and instead simply monitor for the CommandEnded event (in lieu of CommandWillStart, CommandCancelled, etc.), as only when the DwgProps Command has successfully ended do we want our supplementary action to take place (in this case a regen). Another advantage of using Visual LISP in this case is that we can regen the viewports without using another Command, as this has been exposed to the ActiveX API. What does all of this look like? Simple; to test load this psuedo-code: (vl-load-com) (defun DwgPropsCommandReactor:Start () (or *DwgPropsCommandReactor* (setq *DwgPropsCommandReactor* (vlr-command-reactor "DwgPropsCommandReactor" '( (:vlr-commandended . DwgPropsCallback:CommandEnded) ) ) ) ) (prompt "\n >> DwgProps command reactor loaded ") (princ) ) (defun DwgPropsCallback:CommandEnded (rea cmd) (if (wcmatch (strcase (car cmd)) "DWGPROPS") (vla-regen (vla-get-activedocument (vlax-get-acad-object)) acAllViewports ) ) ) (defun c:StopR () (if *DwgPropsCommandReactor* (progn (vlr-remove *DwgPropsCommandReactor*) (setq *DwgPropsCommandReactor* nil) (prompt "\n** DwgProps command reactor stopped ** ") ) ) (princ) ) (DwgPropsCommandReactor:Start) ** Note - Be sure to NOT have the DwgProps Command undefined. ** Edit to add - I've also included a "STOPR" command so that if you'd like to turn this reactor of, you may. HTH Edited October 26, 2012 by BlackBox Quote
Keywordkid Posted October 29, 2012 Author Posted October 29, 2012 Many Thanks RenderMan, Glad my idea may prove useful I'll give your code a try and see if I don't make a mess of it Quote
Keywordkid Posted October 29, 2012 Author Posted October 29, 2012 Thanks RenderMan - This works a treat! I just need to update the company Ribbon tools to include DWGPROPS to make it simple to run. Quote
Keywordkid Posted October 30, 2012 Author Posted October 30, 2012 HI RM, Related to my initial idea, do you know if there is a method for pre-selecting the 'custom' tab in the DWGPROPS dialogue? - I want to make it as easy as possible to edit the fields for the users without running through instructions and tutorials. Thanks, KWK Quote
BlackBox Posted October 30, 2012 Posted October 30, 2012 Keywordkid said: Thanks RenderMan - This works a treat! I just need to update the company Ribbon tools to include DWGPROPS to make it simple to run. Sorry for the delayed response - You're welcome, I'm happy to help. Keywordkid said: Related to my initial idea, do you know if there is a method for pre-selecting the 'custom' tab in the DWGPROPS dialogue? - I want to make it as easy as possible to edit the fields for the users without running through instructions and tutorials. Unfortunately not that I am aware of; once within a Command's dialog, AutoLISP, and even Visual LISP for that matter, are of little use. Quote
Keywordkid Posted October 30, 2012 Author Posted October 30, 2012 I thought that might be the case when Googling gave me no useful results, I've resorted to some text instructions in Defpoints just off the side of the Layout and hope the users will actually read it!! Thanks for your help. Quote
Guest kruuger Posted October 30, 2012 Posted October 30, 2012 Keywordkid said: HI RM, Related to my initial idea, do you know if there is a method for pre-selecting the 'custom' tab in the DWGPROPS dialogue? Thanks, KWK yes, with own custom prop dcl window pros: - multiple delete - reorder, up-down cons: - not re-sizable kruuger Cup.dclFetching info... EditCustomProperties.lspFetching info... Quote
Keywordkid Posted October 30, 2012 Author Posted October 30, 2012 This looks interesting, is it just the dcl file that I need to edit for my preferred fields? Quote
Guest kruuger Posted October 30, 2012 Posted October 30, 2012 Keywordkid said: This looks interesting, is it just the dcl file that I need to edit for my preferred fields? what do mean by fields ? you can change width of DCL to make it wider. more props looks like this: kruuger Quote
Keywordkid Posted October 30, 2012 Author Posted October 30, 2012 Hi kruuger, I think we may be at cross purposes. I have set up new fields in the drawing properties, which are applied to the title block details for each layout tab on our template(s). The fields are defined in the custom tab of DWGPROPS and prefilled with (suggestions/examples), I was hoping that I could direct users to the custom tab to edit the fields according to their project parameters. I have just tried your files and see how they come up which would be great if the same editing features were available as in DWGPROPS. Please correct me if I'm mistaken. Thanks, KWK (By the way this code is very useful for re-ordering the values logically without starting over - just organised my properties more logically - thanks) Quote
Guest kruuger Posted October 30, 2012 Posted October 30, 2012 Keywordkid said: Hi kruuger, I think we may be at cross purposes. I have set up new fields in the drawing properties, which are applied to the title block details for each layout tab on our template(s). The fields are defined in the custom tab of DWGPROPS and prefilled with (suggestions/examples), I was hoping that I could direct users to the custom tab to edit the fields according to their project parameters. I have just tried your files and see how they come up which would be great if the same editing features were available as in DWGPROPS. Please correct me if I'm mistaken. Thanks, KWK (By the way this code is very useful for re-ordering the values logically without starting over - just organised my properties more logically - thanks) why users can't use my program instead of dwgprops ? it is the same properties. kruuger Quote
dober Posted October 31, 2012 Posted October 31, 2012 Thank kruuger Something I've been looking long :) Danke kruuger Sowas suche ich schon lange Quote
Guest kruuger Posted October 31, 2012 Posted October 31, 2012 thanks dober, nod684 how usefull will be import/export to file guys ? maybe resizable window (3 states) ? kruuger Quote
Keywordkid Posted October 31, 2012 Author Posted October 31, 2012 Hi Kruuger, I looked at your program again and realised my mistake, I didn't double click each property I was single clicking expecting it to hilight the selected property as the DWGPROPS dialogue does but I now realise you have a separate pop up. Thanks, KWK Quote
nod684 Posted October 31, 2012 Posted October 31, 2012 kruuger said: thanks dober, nod684 how usefull will be import/export to file guys ? maybe resizable window (3 states) ? kruuger Krugger, the only difference is that when i use Expresstool's Propulate command, it can update multiple drawings' custom properties. your routine is good for one drawing (or am i mistaken) but is still as good. haven't tried the import/export yet though Quote
Guest kruuger Posted October 31, 2012 Posted October 31, 2012 we can add also dwgprops to folder with files via ObjectDBX (defun c:PRO (/ _AddCustom) (defun _AddCustom ( doc ) (vla-AddCustomInfo (vla-get-SummaryInfo doc) "One" "1") ) (LM:ODBX '_AddCustom nil T) (princ) ) need Lee wraper: http://lee-mac.com/odbxbase.html kruuger Quote
Keywordkid Posted October 31, 2012 Author Posted October 31, 2012 For clarity to my users I have edited the label to include some instruction so they don't make my mistake: I just edited the CUP.dcl //===================================// // MAIN_DIALOG // //===================================// CUP : dialog { label = "Custom properties"; width = 62; height = 5; : row { : list_box { key = "PROP"; label = "Name (Double click each property to edit)"; width = 35; multiple_select = true; fixed_width_font = true; } BUTTON_EDIT; } BUTTON_OK_CANCEL; } Thanks Kruuger Quote
Guest kruuger Posted October 31, 2012 Posted October 31, 2012 good point Keywordkid. to get more space you can delete fixed_width_fint line (standard font) kruuger Quote
Recommended Posts
Join the conversation
You can post now and register later. If you have an account, sign in now to post with your account.
Note: Your post will require moderator approval before it will be visible.